#methods implemented:  con, bil, bic, nn, con2
#target_grid has to be either a grid recognised by CDO or a NETCDF file
# requires CDO_1.9.8 or newer versions when using nn method
Interpolation <- function(exp, target_grid, method, ...) {

  require(s2dv)
 
  # Input data must be an s2dv_cube object
  if (!inherits(exp,'s2dv_cube')) {
    stop("Parameter 'exp' must be of the class 's2dv_cube'")
  }

  # Regrid with CDO
  res <- CDORemap(data_array = exp$data, 
                  lats = exp$lat, 
                  lons = exp$lon, 
                  grid = target_grid, 
                  method = method, 
                  ...)
 
  # Create an s2dv_cube object
  res_s2dv <- suppressWarnings(s2dv_cube(data = res$data_array, lon = res$lons, lat = res$lats))

  return(res_s2dv)
}



