
library(startR)
library(s2dv)
library(CSTools)
source('/esarchive/scratch/jramon/GitLab_jramon/downscaling/R/functions.R')

plotpath <- '/esarchive/scratch/jramon/downscaling/plots'
target_grid <- '/esarchive/recon/ecmwf/era5/daily/tasmax-r1440x721cds/tasmax_201702.nc'

lonmin <- -22
lonmax <- 45
latmin <- 27
latmax <- 72

#obs2 <- startR::Start(dat = '/esarchive/recon/ecmwf/era5/daily/$var$-r1440x721cds/$var$_201702.nc',
#                     var = 'tasmax', time = indices(1:5), lat = values(list(latmin, latmax)),
#                     lat_reorder = Sort(decreasing = TRUE), lon = values(list(lonmin, lonmax)),
#                     lon_reorder = CircularSort(-180, 180), 
#                     synonims = list(var = c('var','variable'), lon = c('lon', 'longitude'), 
#                     lat = c('lat', 'latitude')), return_vars = list(lat = NULL, lon = NULL),
#                     num_procs = 1, retrieve = TRUE)

#exp2 <- startR::Start(dat = '/esarchive/exp/ecmwf/system5c3s/daily/$var$/$var$_20170201.nc',
#                     var = 'tasmax', time = indices(1:5), member = indices(1:3),
#                     lat = values(list(latmin, latmax)), lat_reorder = Sort(decreasing = TRUE), 
#                     lon = values(list(lonmin, lonmax)), lon_reorder = CircularSort(-180, 180),
#                     synonims = list(var = c('var','variable'), lon = c('lon', 'longitude'), 
#                     lat = c('lat', 'latitude'), member = c('member','ensemble')),
#                     return_vars = list(lat = NULL, lon = NULL),
#                     num_procs = 1, retrieve = TRUE)
#names(dim(exp))[5] <- 'sdate'
#names(dim(obs))[5] <- 'sdate'

#lat_obs <- as.numeric(attr(obs,'Variables')$dat$lat)
#lon_obs <- as.numeric(attr(obs,'Variables')$dat$lon)
#lat_exp <- as.numeric(attr(exp,'Variables')$dat$lat)
#lon_exp <- as.numeric(attr(exp,'Variables')$dat$lon)

obs <- CST_Load(var = 'tasmax',
                obs = 'era5',
                sdates = c('20170201','20170301','20170401','20170501','20170601'),
                leadtimemax = 1,
                latmin = latmin, latmax = latmax, lonmin = lonmin, lonmax = lonmax,
                output = 'lonlat')

exp <- CST_Load(var = 'tasmax',
                exp = 'system5c3s',
                nmember = 3,
                sdates = c('20170201','20170301','20170401','20170501','20170601'),
                leadtimemax = 1,
                latmin = latmin, latmax = latmax, lonmin = lonmin, lonmax = lonmax,
                output = 'lonlat')

int_methods <- c('con', 'bil', 'bic', 'nn', 'con2')
bc_methods <- c('sbc', 'cal', 'qm')

for (i in seq(int_methods)) {
  for (b in seq(bc_methods)) {
    downscaled <- Intbc(exp = exp, obs = obs, target_grid = target_grid, 
                        int_method = int_methods[i], bc_method = bc_methods[b], ncores = 4)
    lats <- downscaled$lats
    lons <- downscaled$lons 
    data <- downscaled$data_array
    s2dv::PlotEquiMap(var = data[1,1,1,1,,], lat = lats, lon = lons, filled.continents = FALSE, 
                      toptitle = paste0(int_methods[i], ' ', bc_methods[b]), 
                      fileout = file.path(plotpath, paste0(int_methods[i],'-',bc_methods[b],'.png')))
  }
}




